<template>
  <v-row>
    <v-col>
      <div class="mb-8 text-h1">
        Documents de référence
      </div>

      <div class="mb-8 w-100 d-flex justify-space-between align-center">
        <v-text-field v-model="query" placeholder="Recherche" clearable data-cy="DocumentListSearchInput" density="compact"
          rounded variant="outlined" color="primary" hide-details max-width="400" bgColor="white">
          <template #append-inner v-if="!query">
            <v-icon>search</v-icon>
          </template>
        </v-text-field>
      </div>

      <v-data-table :headers="headers" :items="documentsByCategory" :search="query" item-key="name" disable-pagination
        hide-default-footer show-expand density="compact" class="airvam-table" expand-on-click
        no-data-text="Aucun document ne correspond à cette recherche">
        <!-- <template #group-header="{ items, isOpen, toggle }">
          <v-icon @click="toggle">
            {{ isOpen ? 'expand_less' : 'expand_more' }}
          </v-icon>
          {{ items[0].category }}
        </template> -->

        <template #item.name="{ item }">
          {{ item.name }}
          <v-badge :content="item.documents.length" inline> </v-badge>
        </template>

        <template #expanded-row="{ columns, item }">
          <td :colspan="columns.length">
            <div v-for="(document, index) in item.documents" :key="document.id">
              <v-divider v-if="index > 0"></v-divider>
              <div class="mt-2 mb-2 cursor-pointer d-flex align-center justify-space-between"
                @click.stop="downloadDocument(document)">
                {{ decodeURI(document.name) }}
                <v-btn icon size="x-small" data-cy="DocumentListDownloadBtn" class="action" flat>
                  <v-icon>file_download</v-icon>
                </v-btn>
              </div>
            </div>
          </td>
        </template>
      </v-data-table>
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { Document } from "~/dto/document.dto";

const { documents } = storeToRefs(useStore());
const { $api, $toast } = useNuxtApp();

const query = ref('');
const headers: Ref<any[]> = ref([
  { title: 'Nom', value: 'name', sortable: false },
]);


const documentsByCategory = computed(() => {
  const categories = [...new Set(documents.value.map(d => d.category))];
  const toReturn = categories.map(c => {
    return {
      name: c || 'Aucune catégorie',
      documents: documents.value.filter(d => d.category === c),
    };
  });
  toReturn.sort((a, b) => {
    return ('' + a.name).localeCompare(b.name);
  });
  return toReturn;
});

const downloadDocument = async (doc: Document) => {
  try {
    const file = await $api.document.getOneDocument(doc.id);
    if (!file) {
      $toast.error("Le document n'existe pas");
      return;
    }
    const fileURL = window.URL.createObjectURL(new Blob([file]));
    const fileLink = document.createElement('a');

    fileLink.href = fileURL;
    fileLink.setAttribute('download', doc.name);
    document.body.appendChild(fileLink);

    fileLink.click();
  } catch (e) {
    $toast.error("Erreur lors du téléchargement du document");
  }
};
</script>
